((Drupal) => {
  // LegalWeb Cloud Enhancements.
  const POPUP                    = '.lwb-pp, .sp-dsgvo-privacy-popup';
  const OVERLAY                  = '.lwb-pp-overlay, .sp-dsgvo-popup-overlay';
  const OVERLAY_CLASSNAME        = 'lwb-pp-overlay';
  const OVERLAY_LEGACY_CLASSNAME = 'sp-dsgvo-popup-overlay';
  const BUTTON_CLOSE             = '.lwb-pp-close, .sp-dsgvo-popup-close';
  const CHECKBOX                 = '.switch-input:not(.switch-input-category)';

  Drupal.behaviors.legalwebCloudEnhancements = {
    attach(context, settings)  {
      this.overlay = context.querySelector(OVERLAY);
      if (!this.overlay) {
        return;
      }
      // Initialize.
      this.initValues();

      if (settings.legalwebCloudEnhancements.removeCloseButton) {
        this.removeCloseButton();
      }

      if (settings.legalwebCloudEnhancements.disableOutsideClick) {
        this.disableOutsideClickBehavior();
      }
    },
    initValues() {
      this.popup = this.overlay.querySelector(POPUP);
    },
    disableOutsideClickBehavior() {
      window.addEventListener('click', this._clickOutHandler, { capture: true });
      window.addEventListener('touchstart', this._clickOutHandler, { capture: true });
    },
    removeCloseButton() {
      const closeBtn = this.popup.querySelector(BUTTON_CLOSE);
      if (null !== closeBtn) {
        closeBtn.remove();
      }
    },

    _clickOutHandler(e) {
      if (e.target.classList.contains(OVERLAY_CLASSNAME) || e.target.classList.contains(OVERLAY_LEGACY_CLASSNAME)) {
        e.stopPropagation();
        return false;
      }
    },
  };

})(Drupal);
