(function (Drupal) {
  var POPUP = '.lwb-pp, .sp-dsgvo-privacy-popup';
  var OVERLAY = '.lwb-pp-overlay, .sp-dsgvo-popup-overlay';
  var OVERLAY_CLASSNAME = 'lwb-pp-overlay';
  var OVERLAY_LEGACY_CLASSNAME = 'sp-dsgvo-popup-overlay';
  var BUTTON_CLOSE = '.lwb-pp-close, .sp-dsgvo-popup-close';
  var CHECKBOX = '.switch-input:not(.switch-input-category)';
  Drupal.behaviors.legalwebCloudEnhancements = {
    attach: function attach(context, settings) {
      this.overlay = context.querySelector(OVERLAY);
      if (!this.overlay) {
        return;
      }
      this.initValues();
      if (settings.legalwebCloudEnhancements.removeCloseButton) {
        this.removeCloseButton();
      }
      if (settings.legalwebCloudEnhancements.disableOutsideClick) {
        this.disableOutsideClickBehavior();
      }
    },
    initValues: function initValues() {
      this.popup = this.overlay.querySelector(POPUP);
    },
    disableOutsideClickBehavior: function disableOutsideClickBehavior() {
      window.addEventListener('click', this._clickOutHandler, {
        capture: true
      });
      window.addEventListener('touchstart', this._clickOutHandler, {
        capture: true
      });
    },
    removeCloseButton: function removeCloseButton() {
      var closeBtn = this.popup.querySelector(BUTTON_CLOSE);
      if (null !== closeBtn) {
        closeBtn.remove();
      }
    },
    _clickOutHandler: function _clickOutHandler(e) {
      if (e.target.classList.contains(OVERLAY_CLASSNAME) || e.target.classList.contains(OVERLAY_LEGACY_CLASSNAME)) {
        e.stopPropagation();
        return false;
      }
    }
  };
})(Drupal);